#!/bin/sh
# 
# Licensed Materials - Property of IBM
#
# <AFBA_PID>
#
# (C) Copyright IBM Corp. <AFBA_YEAR> All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
# 

source ~/.baprofile
source $IOC_BASE_DIR/variables.properties
log.info "Start to Install Impact Content."

cd $IOC_BASE_DIR
export SED_SCRIPT_NAME=com.ibm.ife.sed.script.txt
sed -e '/^#/d' $IOC_BASE_DIR/variables.properties | awk -F = '{print "s#~{" $1 "}#" substr($0,index($0,"=")+1) "#g"}' > $IOC_BASE_DIR/$SED_SCRIPT_NAME

log.info "Stop Liberty member01 server."
$LIBERTY_INSTALL_LOCATION/bin/server stop $LIBERTY_CLUSTER_MEMBER

log.info "Delete old war and ear."
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_jslib.war
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_widgets.war
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_logicalmap_ear.ear
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_sample_dno.war

log.info "Copy new ear and war package."
cp -f $IOC_BASE_DIR/content/apps/*.ear $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps
cp -f $IOC_BASE_DIR/content/apps/*.war $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps


log.info "Extract ife_frwk_app.ear ............."
unzip $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear -d $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear
mv $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear

log.info "Extract ife_frwk_service.war ife_frwk_app.ear ............."
unzip $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear/ife_frwk_service.war -d $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear/ife_frwk_service
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear/ife_frwk_service.war
mv $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear/ife_frwk_service $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear/ife_frwk_service.war

log.info "Extract ife_frwk_web.war ife_frwk_app.ear ............."
unzip $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear/ife_frwk_web.war -d $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear/ife_frwk_web
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear/ife_frwk_web.war
mv $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear/ife_frwk_web $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_frwk_app.ear/ife_frwk_web.war


log.info "Extract ife_aha_mig_app.ear ............."
unzip $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear -d $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear
mv $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear

unzip $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_service_mig.war -d $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_service_mig
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_service_mig.war
mv $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_service_mig $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_service_mig.war

mv $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_service_mig.war/WEB-INF/classes/com/ibm/ife/aha/dao/AssetHealthAssessmentDAO.class $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_service_mig.war/WEB-INF/classes/com/ibm/ife/aha/dao/AssetHealthAssessmentDAO.class.bak
cp -f  $IOC_BASE_DIR/content/apps/AssetHealthAssessmentDAO.class $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_service_mig.war/WEB-INF/classes/com/ibm/ife/aha/dao

unzip $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_web.war -d $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_web
rm -rf $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_web.war
mv $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_web $LIBERTY_INSTALL_LOCATION/usr/servers/$LIBERTY_CLUSTER_MEMBER/apps/ife_aha_mig_app.ear/ife_aha_web.war


log.info "Start Liberty member01 server."
$LIBERTY_INSTALL_LOCATION/bin/server start $LIBERTY_CLUSTER_MEMBER


cp -rf  $IOC_BASE_DIR/content/metaDataCSV  /opt/IBM/energy

chmod +x /opt/IBM/energy/metaDataCSV/*.sh
