#!/bin/sh
# 
# Licensed Materials - Property of IBM
#
# <AFBA_PID>
#
# (C) Copyright IBM Corp. <AFBA_YEAR> All rights reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
# 
source ~/.baprofile
source $IOC_BASE_DIR/variables.properties

log.info "Start to Install Impact Content."

cd $IOC_BASE_DIR
export SED_SCRIPT_NAME=com.ibm.ife.sed.script.txt
sed -e '/^#/d' $IOC_BASE_DIR/variables.properties | awk -F = '{print "s#~{" $1 "}#" substr($0,index($0,"=")+1) "#g"}' > $IOC_BASE_DIR/$SED_SCRIPT_NAME

DB_PASSWORD_ENCODED=`$LIBERTY_INSTALL_LOCATION/bin/securityUtility encode $DB_PASSWORD`
BOB_PASSWORD_ENCODED=`$LIBERTY_INSTALL_LOCATION/bin/securityUtility encode $BOB_PASSWORD`
USER1_PASSWORD_ENCODED=`$LIBERTY_INSTALL_LOCATION/bin/securityUtility encode $USER1_PASSWORD`
USER2_PASSWORD_ENCODED=`$LIBERTY_INSTALL_LOCATION/bin/securityUtility encode $USER2_PASSWORD`

sed -i s#DB_PASSWORD=$DB_PASSWORD#DB_PASSWORD=$DB_PASSWORD_ENCODED#g $IOC_BASE_DIR/variables.properties
sed -i s#BOB_PASSWORD=$BOB_PASSWORD#BOB_PASSWORD=$BOB_PASSWORD_ENCODED#g $IOC_BASE_DIR/variables.properties
sed -i s#USER1_PASSWORD=$USER1_PASSWORD#USER1_PASSWORD=$USER1_PASSWORD_ENCODED#g $IOC_BASE_DIR/variables.properties
sed -i s#USER2_PASSWORD=$USER2_PASSWORD#USER2_PASSWORD=$USER2_PASSWORD_ENCODED#g $IOC_BASE_DIR/variables.properties

cd $IOC_BASE_DIR
export SED_SCRIPT_NAME_FOR_LIBERTY=com.ibm.ife.sed.script.txt
sed -e '/^#/d' $IOC_BASE_DIR/variables.properties | awk -F = '{print "s#~{" $1 "}#" substr($0,index($0,"=")+1) "#g"}' > $IOC_BASE_DIR/$SED_SCRIPT_NAME_FOR_LIBERTY


su - root -c "$LIBERTY_INSTALL_LOCATION/bin/server stop $ASK_SERVER"

sed -i -c -f $IOC_BASE_DIR/$SED_SCRIPT_NAME_FOR_LIBERTY $IOC_BASE_DIR/content/config/ask_app_config.xml

cp -rf $IOC_BASE_DIR/content/apps/*.ear $LIBERTY_INSTALL_LOCATION/usr/servers/$ASK_SERVER/apps
cp -rf $IOC_BASE_DIR/content/config/*.xml $LIBERTY_INSTALL_LOCATION/usr/servers/$ASK_SERVER/

su - root -c "$LIBERTY_INSTALL_LOCATION/bin/server start $ASK_SERVER"