CONNECT RESET;
CONNECT TO IBMPMQ USER db2inst1 using pw4iow16;

SET CURRENT_SCHEMA=PMQSCH;

---------------------------------------
-- DDL for ControlChartConstants
---------------------------------------	
CREATE TABLE CONTROLCHARTCONSTANTS  (
		  "SAMPLE_SIZE" INTEGER NOT NULL , 
		  "A2" DOUBLE NOT NULL , 
		  "A3" DOUBLE NOT NULL , 
		  "D2" DOUBLE NOT NULL , 
		  "D3" DOUBLE NOT NULL , 
		  "D4" DOUBLE NOT NULL , 
		  "B3" DOUBLE NOT NULL , 
		  "B4" DOUBLE NOT NULL )
		  ; 

insert into ControlChartConstants values(2,1.88,2.659,1.128,0,3.267,0,3.267);
insert into ControlChartConstants values(3,1.023,1.954,1.693,0,2.574,0,2.568);
insert into ControlChartConstants values(4,0.729,1.628,2.059,0,2.282,0,2.266);
insert into ControlChartConstants values(5,0.577,1.427,2.326,0,2.114,0,2.089);
insert into ControlChartConstants values(6,0.483,1.287,2.534,0,2.004,0.03,1.97);
insert into ControlChartConstants values(7,0.419,1.182,2.704,0.076,1.924,0.118,1.882);
insert into ControlChartConstants values(8,0.373,1.099,2.847,0.136,1.864,0.185,1.815);
insert into ControlChartConstants values(9,0.337,1.032,2.97,0.184,1.816,0.239,1.761);
insert into ControlChartConstants values(10,0.308,0.975,3.078,0.223,1.777,0.284,1.716);
insert into ControlChartConstants values(11,0.285,0.927,3.173,0.256,1.744,0.321,1.679);
insert into ControlChartConstants values(12,0.266,0.886,3.258,0.283,1.717,0.354,1.646);
insert into ControlChartConstants values(13,0.249,0.85,3.336,0.307,1.693,0.382,1.618);
insert into ControlChartConstants values(14,0.235,0.817,3.407,0.328,1.672,0.406,1.594);
insert into ControlChartConstants values(15,0.223,0.789,3.472,0.347,1.653,0.428,1.572);
insert into ControlChartConstants values(16,0.212,0.763,3.532,0.363,1.637,0.448,1.552);
insert into ControlChartConstants values(17,0.203,0.739,3.588,0.378,1.622,0.466,1.534);
insert into ControlChartConstants values(18,0.194,0.718,3.64,0.391,1.608,0.482,1.518);
insert into ControlChartConstants values(19,0.187,0.698,3.689,0.403,1.597,0.497,1.503);
insert into ControlChartConstants values(20,0.18,0.68,3.735,0.415,1.585,0.51,1.49);
insert into ControlChartConstants values(21,0.173,0.663,3.778,0.425,1.575,0.523,1.477);
insert into ControlChartConstants values(22,0.167,0.647,3.819,0.434,1.566,0.534,1.466);
insert into ControlChartConstants values(23,0.162,0.633,3.858,0.443,1.557,0.545,1.455);
insert into ControlChartConstants values(24,0.157,0.619,3.895,0.451,1.548,0.555,1.445);
insert into ControlChartConstants values(25,0.153,0.606,3.931,0.459,1.541,0.565,1.435);

------------------------------------------------
-- DDL Statements for table "MAINTENANCE_ADM_RECOMMENDATIONS"
------------------------------------------------

CREATE TABLE "MAINTENANCE_ADM_RECOMMENDATIONS"  (
		  "KPI_DATE" DATE NOT NULL , 
		  "RESOURCE_ID" INTEGER NOT NULL , 
		  "FORECASTED_DAYS" INTEGER , 
		  "FORECASTED_DATE" DATE , 
		  "SCHEDULED_DAYS" INTEGER , 
		  "SCHEDULED_DATE" DATE , 
		  "DEVIATION" INTEGER , 
		  "DEVIATION_PERCENT" DOUBLE , 
		  "MHS" DOUBLE , 
		  "LOCATION_ID" INTEGER NOT NULL , 
		  "TENANT_ID" INTEGER NOT NULL , 
		  "RECOMMENDATION" VARCHAR(30) ); 

------------------------------------------------
-- DDL Statements for table "MAINTENANCE_TRENDS"
------------------------------------------------

CREATE TABLE "MAINTENANCE_TRENDS"  (
		  "RESOURCE_ID" INTEGER NOT NULL , 
		  "KPI_DATE" DATE NOT NULL , 
		  "ISFAIL" SMALLINT , 
		  "ISPLANNED" SMALLINT , 
		  "ISFUTURE" SMALLINT , 
		  "ISPREDICTED" SMALLINT , 
		  "ISPREDICTEDBREAKDOWN_ALL" SMALLINT , 
		  "FORECASTED_DAYS" INTEGER , 
		  "MHS" DOUBLE , 
		  "ISSCHEDULED_FUTURE" SMALLINT , 
		  "ISBREAKDOWN_FORECASTED" SMALLINT , 
		  "ISBREAKDOWN_HISTORICAL" SMALLINT , 
		  "ISPLANNED_HISTORICAL" SMALLINT , 
		  "MHS_HISTORICAL" DOUBLE , 
		  "MHS_FUTURE" DOUBLE , 
		  "LOCATION_ID" INTEGER NOT NULL , 
		  "TENANT_ID" INTEGER NOT NULL ); 


-- DDL Statements for primary key on Table "MAINTENANCE_TRENDS"

ALTER TABLE "MAINTENANCE_TRENDS" 
	ADD CONSTRAINT "MAINTENANCE_TRENDS" PRIMARY KEY
		("KPI_DATE",
		 "LOCATION_ID",
		 "RESOURCE_ID",
		 "TENANT_ID");

-----------------------------------------------
-- DDL Statements for table "MAINTENANCE_DAILY"
------------------------------------------------

CREATE TABLE "MAINTENANCE_DAILY"  (
		  "KPI_DATE" DATE NOT NULL , 
		  "RESOURCE_ID" INTEGER NOT NULL , 
		  "FORECASTED_DAYS" INTEGER , 
		  "FORECASTED_DATE" DATE , 
		  "SCHEDULED_DAYS" INTEGER , 
		  "SCHEDULED_DATE" DATE , 
		  "DEVIATION" INTEGER , 
		  "DEVIATION_PERCENT" DOUBLE , 
		  "MHS" DOUBLE , 
		  "LOCATION_ID" INTEGER NOT NULL , 
		  "TENANT_ID" INTEGER NOT NULL ); 


-- DDL Statements for foreign keys on Table "MAINTENANCE_TRENDS"

ALTER TABLE "MAINTENANCE_TRENDS" 
	ADD CONSTRAINT "MAINTENANCE_TRENDS_LOCATION_KEY_LOOKUP_FK" FOREIGN KEY
		("LOCATION_ID")
	REFERENCES "KEY_LOOKUP"
		("KEY_LOOKUP_ID")
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

ALTER TABLE "MAINTENANCE_TRENDS" 
	ADD CONSTRAINT "MAINTENANCE_TRENDS_RESOURCE_KEY_LOOKUP_FK" FOREIGN KEY
		("RESOURCE_ID")
	REFERENCES "KEY_LOOKUP"
		("KEY_LOOKUP_ID")
	ON DELETE NO ACTION
	ON UPDATE NO ACTION
	ENFORCED
	ENABLE QUERY OPTIMIZATION;

-- DDL Statements for "TOPN_PREDICTORS"

CREATE TABLE "TOPN_PREDICTORS" (		
		"KPI_DATE" DATE NOT NULL,
		"LOCATION_ID" INTEGER  NOT NULL,
		"RESOURCE_ID" INTEGER NOT NULL,
		"PARAMETER" VARCHAR(30) NOT NULL, 
		"IMPORTANCE" DOUBLE NOT NULL, 
		"CUMULATIVE_IMPORTANCE" DOUBLE NOT NULL,   
		"TENANT_ID" INTEGER  NOT NULL
	)
	DATA CAPTURE NONE 
	COMPRESS NO;
	
ALTER TABLE MAINTENANCE_ADM_RECOMMENDATIONS 
ADD CONSTRAINT MAINT_ADM_REC_PK PRIMARY KEY ( KPI_DATE, RESOURCE_ID, LOCATION_ID, TENANT_ID) ADD CONSTRAINT LOC_FK FOREIGN KEY (LOCATION_ID) REFERENCES KEY_LOOKUP (KEY_LOOKUP_ID)  ON DELETE NO ACTION ON UPDATE NO ACTION ENFORCED  ENABLE QUERY OPTIMIZATION 
ADD CONSTRAINT RES_FK FOREIGN KEY (RESOURCE_ID) REFERENCES KEY_LOOKUP (KEY_LOOKUP_ID)  ON DELETE NO ACTION ON UPDATE NO ACTION ENFORCED  ENABLE QUERY OPTIMIZATION 
ADD CONSTRAINT TENANT_FK FOREIGN KEY (TENANT_ID) REFERENCES TENANT (TENANT_ID)  ON DELETE NO ACTION ON UPDATE NO ACTION ENFORCED  ENABLE QUERY OPTIMIZATION ;


ALTER TABLE MAINTENANCE_DAILY 
ADD CONSTRAINT MAINT_DAILY_PK PRIMARY KEY ( KPI_DATE, RESOURCE_ID, LOCATION_ID, TENANT_ID) ADD CONSTRAINT LOC_FK FOREIGN KEY (LOCATION_ID) REFERENCES KEY_LOOKUP (KEY_LOOKUP_ID)  ON DELETE NO ACTION ON UPDATE NO ACTION ENFORCED  ENABLE QUERY OPTIMIZATION 
ADD CONSTRAINT RES_FK FOREIGN KEY (RESOURCE_ID) REFERENCES KEY_LOOKUP (KEY_LOOKUP_ID)  ON DELETE NO ACTION ON UPDATE NO ACTION ENFORCED  ENABLE QUERY OPTIMIZATION 
ADD CONSTRAINT TENANT_FK FOREIGN KEY (TENANT_ID) REFERENCES TENANT (TENANT_ID)  ON DELETE NO ACTION ON UPDATE NO ACTION ENFORCED  ENABLE QUERY OPTIMIZATION ;


ALTER TABLE TOPN_PREDICTORS ADD CONSTRAINT TOPN_PK PRIMARY KEY ( KPI_DATE, LOCATION_ID, RESOURCE_ID, TENANT_ID, "PARAMETER", IMPORTANCE, CUMULATIVE_IMPORTANCE) 
ADD CONSTRAINT LOC_FK FOREIGN KEY (LOCATION_ID) REFERENCES KEY_LOOKUP (KEY_LOOKUP_ID)  ON DELETE NO ACTION ON UPDATE NO ACTION ENFORCED  ENABLE QUERY OPTIMIZATION 
ADD CONSTRAINT RES_FK FOREIGN KEY (RESOURCE_ID) REFERENCES KEY_LOOKUP (KEY_LOOKUP_ID)  ON DELETE NO ACTION ON UPDATE NO ACTION ENFORCED  ENABLE QUERY OPTIMIZATION 
ADD CONSTRAINT TENANT_FK FOREIGN KEY (TENANT_ID) REFERENCES TENANT (TENANT_ID)  ON DELETE NO ACTION ON UPDATE NO ACTION ENFORCED  ENABLE QUERY OPTIMIZATION ;

--DDL for UI changes
CREATE TABLE "PMQ_USER" (
  "USER_ID" INTEGER NOT NULL, 
  "USER_WAS_FR_ID" VARCHAR(1024) NOT NULL, 
  "TENANT_ID" INTEGER NOT NULL
 );
 
CREATE TABLE "PMQ_DASHBOARD" (
  "DASHBOARD_ID" INTEGER NOT NULL, 
  "DASHBOARD_NAME" VARCHAR(256) NOT NULL, 
  "NO_OF_COLUMNS" INTEGER NOT NULL DEFAULT 1, 
  "USER_ID" INTEGER NOT NULL, 
  "TENANT_ID" INTEGER NOT NULL
 );

CREATE TABLE "PMQ_CHART" (
  "CHART_ID" INTEGER NOT NULL, 
  "COLUMN_NUMBER" INTEGER NOT NULL, 
  "COLUMN_DISPLY_ORDER" INTEGER NOT NULL, 
  "DASHBOARD_ID" INTEGER NOT NULL, 
  "TENANT_ID" INTEGER NOT NULL
 );

CREATE TABLE "PMQ_CHART_CONFIG" (
  "CHART_CONFIG_ID" INTEGER NOT NULL, 
  "RESOURCE_ID" INTEGER NOT NULL, 
  "PROFILE_VARIABLE_ID" INTEGER NOT NULL, 
  "LANGUAGE_ID" INTEGER NOT NULL,
  "CHART_ID" INTEGER NOT NULL, 
  "TENANT_ID" INTEGER NOT NULL
 );


ALTER TABLE "PMQ_USER" ADD CONSTRAINT "PMQ_USER_PK" PRIMARY KEY ( "USER_ID" );
ALTER TABLE "PMQ_DASHBOARD" ADD CONSTRAINT "PMQ_DASHBOARD_PK" PRIMARY KEY ( "DASHBOARD_ID" );
ALTER TABLE "PMQ_CHART" ADD CONSTRAINT "PMQ_CHART_PK" PRIMARY KEY ( "CHART_ID" );
ALTER TABLE "PMQ_CHART_CONFIG" ADD CONSTRAINT "PMQ_CHART_CONFIG_PK" PRIMARY KEY ( "CHART_CONFIG_ID" );  

ALTER TABLE "PMQ_USER" ADD CONSTRAINT "PMQ_USER_TENANT_FK" FOREIGN KEY ( "TENANT_ID" ) REFERENCES "TENANT" ( "TENANT_ID" );
ALTER TABLE "PMQ_DASHBOARD" ADD CONSTRAINT "PMQ_DASHBOARD_TENANT_FK" FOREIGN KEY ( "TENANT_ID" ) REFERENCES "TENANT" ( "TENANT_ID" );
ALTER TABLE "PMQ_CHART" ADD CONSTRAINT "PMQ_CHART_TENANT_FK" FOREIGN KEY ( "TENANT_ID" ) REFERENCES "TENANT" ( "TENANT_ID" );
ALTER TABLE "PMQ_CHART_CONFIG" ADD CONSTRAINT "PMQ_CHART_CONFIG_TENANT_FK" FOREIGN KEY ( "TENANT_ID" ) REFERENCES "TENANT" ( "TENANT_ID" );

ALTER TABLE "PMQ_DASHBOARD" ADD CONSTRAINT "PMQ_DASHBOARD_PMQ_USER_FK" FOREIGN KEY ( "USER_ID" ) REFERENCES "PMQ_USER" ( "USER_ID" ) ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "PMQ_CHART" ADD CONSTRAINT "PMQ_CHART_PMQ_DASHBOARD_FK" FOREIGN KEY ( "DASHBOARD_ID" ) REFERENCES "PMQ_DASHBOARD" ( "DASHBOARD_ID" ) ON DELETE CASCADE ON UPDATE NO ACTION;
ALTER TABLE "PMQ_CHART_CONFIG" ADD CONSTRAINT "PMQ_CHART_CONFIG_PMQ_CHART_FK" FOREIGN KEY ( "CHART_ID" ) REFERENCES "PMQ_CHART" ( "CHART_ID" ) ON DELETE CASCADE ON UPDATE NO ACTION; 
ALTER TABLE "PMQ_CHART_CONFIG" ADD CONSTRAINT "LANGUAGE_ID_FK" FOREIGN KEY ( "LANGUAGE_ID" ) REFERENCES "LANGUAGE" ( "LANGUAGE_ID" );
ALTER TABLE "PMQ_CHART_CONFIG" ADD CONSTRAINT "PMQ_CHART_CONFIG_MASTER_RESOURCE_FK" FOREIGN KEY ( "RESOURCE_ID", "LANGUAGE_ID" ) REFERENCES "MASTER_RESOURCE" ( "MASTER_RESOURCE_ID", "LANGUAGE_ID" );
ALTER TABLE "PMQ_CHART_CONFIG" ADD CONSTRAINT "PMQ_CHART_CONFIG_MASTER_PROFILE_VARIABLE_FK" FOREIGN KEY ( "PROFILE_VARIABLE_ID", "LANGUAGE_ID" ) REFERENCES "MASTER_PROFILE_VARIABLE" ( "MASTER_PROFILE_VARIABLE_ID", "LANGUAGE_ID" );

ALTER TABLE "PMQ_USER" ADD CONSTRAINT "PMQ_USER_UN" UNIQUE ( "USER_WAS_FR_ID", "TENANT_ID" );


CREATE SEQUENCE "PMQ_USER_SEQ" INCREMENT BY 1 START WITH 1 NOMAXVALUE NOCYCLE CACHE 20;
CREATE SEQUENCE "PMQ_DASHBOARD_SEQ" INCREMENT BY 1 START WITH 1 NOMAXVALUE NOCYCLE CACHE 20;
CREATE SEQUENCE "PMQ_CHART_SEQ" INCREMENT BY 1 START WITH 1 NOMAXVALUE NOCYCLE CACHE 20;
CREATE SEQUENCE "PMQ_CHART_CONFIG_SEQ" INCREMENT BY 1 START WITH 1 NOMAXVALUE NOCYCLE CACHE 20;
----------------------------------------
-- MQT for Performance
----------------------------------------
---CREATE TABLE MAINTENANCE_PROFILE 

SET CURRENT_SCHEMA=PMQSCH;
CREATE TABLE MAINTENANCE_PROFILE AS 
(SELECT L.MASTER_LOCATION_ID,
		RS.MASTER_RESOURCE_ID,
		PV.MASTER_PROFILE_VARIABLE_ID,
		PV.MEASUREMENT_TYPE_ID,
		VT.MASTER_VALUE_TYPE_ID,
		VT.VALUE_TYPE_CD,
		RP.EVENT_CODE_ID,
		RP.PROFILE_DATE,
		RP.LAST_VALUE,
		L.LOCATION_NAME,
		L.LOCATION_CD,
		RS.RESOURCE_NAME,
		RS.RESOURCE_CD1,
		RS.RESOURCE_SUB_TYPE,
		PV.PROFILE_VARIABLE_CD,
		PV.PROFILE_VARIABLE_NAME,
		RS.LANGUAGE_ID AS RESOURCE_LANG,
		RS.TENANT_ID AS RESOURCE_TENANT,
		L.LANGUAGE_ID AS LOCATION_LANG,
		L.TENANT_ID AS LOCATION_TENANT,
		PV.LANGUAGE_ID,
		RP.TENANT_ID
FROM PMQSCH.RESOURCE_PROFILE RP INNER JOIN PMQSCH.MASTER_LOCATION L ON RP.LOCATION_ID = L.MASTER_LOCATION_ID
	INNER JOIN PMQSCH.MASTER_RESOURCE RS ON RP.RESOURCE_ID = RS.MASTER_RESOURCE_ID
	INNER JOIN PMQSCH.MASTER_PROFILE_VARIABLE PV ON RP.PROFILE_VARIABLE_ID = PV.MASTER_PROFILE_VARIABLE_ID
	INNER JOIN PMQSCH.MASTER_VALUE_TYPE VT ON RP.VALUE_TYPE_ID = VT.MASTER_VALUE_TYPE_ID
	
WHERE PV.PROFILE_VARIABLE_CD IN ('MHS','IHS','HS','FDM','SDM','DEV', 'FHS','FFDM','IFDM','DEV_FFDM','DEV_IFDM')
	AND VT.VALUE_TYPE_CD  = 'ACTUAL'

) DATA INITIALLY DEFERRED REFRESH DEFERRED ;
 SET INTEGRITY FOR  PMQSCH.MAINTENANCE_PROFILE ALL IMMEDIATE UNCHECKED;
--REFRESH TABLE PMQSCH.MAINTENANCE_PROFILE;

---CREATE MAINTENACNE_EVENT MQT TABLE

SET CURRENT_SCHEMA=PMQSCH;
CREATE TABLE MAINTENANCE_EVENT AS 
(SELECT E.EVENT_ID,
		E.ASSET_ID,
		E.EVENT_TYPE_ID,
		E.LOCATION_ID,
		EO.MEASUREMENT_TYPE_ID,
		EO.OBSERVATION_TIMESTAMP,
		EO.VALUE_TYPE_ID,
		EO.EVENT_CODE_ID,
		EO.OBSERVATION_TEXT,
		EO.MEASUREMENT,
		EO.OBSERVATION_DATE,
		EO.OBSERVATION_TIME,
		EC.EVENT_CODE,
		MT.MEASUREMENT_TYPE_CD,
		LA.LANGUAGE_ID,
		LA.LANGUAGE_CD
FROM PMQSCH.EVENT E INNER JOIN PMQSCH.EVENT_OBSERVATION EO ON E.EVENT_ID = EO.EVENT_ID
	INNER JOIN PMQSCH.MASTER_EVENT_CODE EC ON EO.EVENT_CODE_ID = EC.MASTER_EVENT_CODE_ID
	INNER JOIN PMQSCH.MASTER_MEASUREMENT_TYPE MT ON EO.MEASUREMENT_TYPE_ID = MT.MASTER_MEASUREMENT_TYPE_ID
	INNER JOIN PMQSCH.LANGUAGE LA ON LA.LANGUAGE_ID = EC.LANGUAGE_ID  
WHERE LA.LANGUAGE_ID = MT.LANGUAGE_ID 
	  AND MT.MEASUREMENT_TYPE_CD IN ('MHS','IHS','HS','FDM','SDM','DEV', 'FHS','FFDM','IFDM','DEV_FFDM','DEV_IFDM')
) DATA INITIALLY DEFERRED REFRESH DEFERRED ;
 SET INTEGRITY FOR  PMQSCH.MAINTENANCE_EVENT ALL IMMEDIATE UNCHECKED;
--REFRESH TABLE PMQSCH.MAINTENANCE_EVENT;


---------------------------------
-- DDL statements for stored procedures
---------------------------------
-- SET CURRENT SCHEMA = "db2inst1";
-- SET CURRENT PATH = "SYSIBM","SYSFUN","SYSPROC","SYSIBMADM","db2inst1";

create procedure Calendar_pop()
Begin
declare i int;--
Declare log_date timestamp;--
Declare shift char(2);--
Declare timeofday time;--
Declare quarter_no int;--
Declare quarter_name varchar(10);--
Declare month_no int;--
Declare month_name varchar(15);--
Declare weekday_no int;--
Declare weekday_name varchar(15);--

set timeofday = '00:00:00';--
set i = 1;--
while i <= 86400 do
 if HOUR(timeofday) < 12 Then
 set shift = 'AM';--
 Else set shift = 'PM';--
 end if;--

insert into event_time (time_of_day,hour_no,hour_caption,shift,time_of_day_text) 
values(timeofday, HOUR(timeofday),HOUR(timeofday),shift,timeofday);--

 set timeofday = timeofday + 1 SECONDS; --DATEADD(ss,1,timeofday) 
 set i = i + 1;--
end while;--

set log_date = '2005-01-01';--
set i = 1;--
while (i <= 7305) do
 set quarter_no = QUARTER(log_date); --
 set quarter_name = YEAR(log_date)||'/Q'||quarter_no;--
 set month_no = MONTH(log_date);--
 set month_name = MONTHNAME(log_date);--
 set weekday_no = DAYOFWEEK(log_date);--
 set weekday_name = DAYNAME(log_date);--

 insert into calendar (cdr_date,year_no,month_no,quarter_no,month_name,quarter_name,weekday_no,weekday_name,year_caption)
VALUES (log_date,YEAR(log_date),month_no, quarter_no, month_name, quarter_name, weekday_no, weekday_name, YEAR(log_date));--
 set log_date = log_date + 1 DAYS; --DATEADD(DD,1,log_date);--
 set i = i + 1;--
end while;--
end
;

-------------------------------------------------
--- Index creation for key_lookup
-------------------------------------------------
CREATE INDEX KEY_LOOKUP_INDEX ON KEY_LOOKUP (TENANT_ID, TABLE_CD, KEY_LOOKUP_CD1, KEY_LOOKUP_CD2, KEY_LOOKUP_CD3, KEY_LOOKUP_CD4, KEY_LOOKUP_CD5); 