@echo off

if "%1"=="" goto :USAGE

set DB_NAME=%1
set DB_INST=%2

@REM initialize informix environment variables
set INFORMIXDIR=D:\PROGRA~1\IBMINF~1
set INFORMIXSERVER=%DB_INST%
set ONCONFIG=onconfig.%INFORMIXSERVER%
set PATH=%INFORMIXDIR%\bin:%PATH%
set INFORMIXSQLHOSTS=%INFORMIXDIR%\etc\sqlhosts.%INFORMIXSERVER%
set DBTEMP=%INFORMIXDIR%\infxtmp
set CLIENT_LOCALE=EN_US.CP1252
set DB_LOCALE=EN_US.8859-1

@REM send to standard output
set DBACCESS=%INFORMIXDIR%\bin\dbaccess.exe -e
set DBCOMMAND=%DBACCESS% %DB_NAME%

set TMP_SQL_FILE=%DBTEMP%\aha_load.sql

echo truncate table AHA.PACKAGE_DEGRADATION; > %TMP_SQL_FILE%
echo truncate table AHA.PACKAGE_TREATMENT_EXCLUDE; >> %TMP_SQL_FILE%
echo truncate table AHA.PACKAGE_TREATMENT_INCLUDE; >> %TMP_SQL_FILE%	
echo truncate table AHA.PACKAGE_TREATMENT; >> %TMP_SQL_FILE%
echo truncate table AHA.PACKAGE_INDEX; >> %TMP_SQL_FILE%
echo truncate table AHA.PACKAGE_FACTOR; >> %TMP_SQL_FILE%
echo truncate table AHA.PACKAGE_DRIVER; >> %TMP_SQL_FILE%	
echo truncate table AHA.PACKAGE_DRIVER; >> %TMP_SQL_FILE%
echo truncate table AHA.ANALYSIS; >> %TMP_SQL_FILE%
echo truncate table AHA.PACKAGE; >> %TMP_SQL_FILE%
echo truncate table AHA.ANALYSIS_YEAR; >> %TMP_SQL_FILE%
echo truncate table AHA.TREATMENT; >> %TMP_SQL_FILE%
echo truncate table AHA.FACTOR; >> %TMP_SQL_FILE%
echo truncate table AHA.DRIVER; >> %TMP_SQL_FILE%
echo load from AHA.DRIVER.csv DELIMITER ',' INSERT INTO AHA.DRIVER; >> %TMP_SQL_FILE%
echo load from AHA.FACTOR.csv DELIMITER ',' INSERT INTO AHA.FACTOR; >> %TMP_SQL_FILE%
echo load from AHA.TREATMENT.csv DELIMITER ',' INSERT INTO AHA.TREATMENT; >> %TMP_SQL_FILE%
echo load from AHA.ANALYSIS_YEAR.csv DELIMITER ',' INSERT INTO AHA.ANALYSIS_YEAR; >> %TMP_SQL_FILE%
echo load from AHA.PACKAGE.csv DELIMITER ',' INSERT INTO AHA.PACKAGE; >> %TMP_SQL_FILE%
echo load from AHA.ANALYSIS.csv DELIMITER ',' INSERT INTO AHA.ANALYSIS; >> %TMP_SQL_FILE%
echo load from AHA.PACKAGE_DRIVER.csv DELIMITER ',' INSERT INTO AHA.PACKAGE_DRIVER(PACKAGE_ID, DRIVER_ID, DRIVER_WEIGHT); >> %TMP_SQL_FILE%
echo load from AHA.PACKAGE_FACTOR.csv DELIMITER ',' INSERT INTO AHA.PACKAGE_FACTOR(PACKAGE_ID, DRIVER_ID, FACTOR_ID, FACTOR_WEIGHT, DEFAULT_VALUE); >> %TMP_SQL_FILE%
echo load from AHA.PACKAGE_INDEX.csv DELIMITER ',' INSERT INTO AHA.PACKAGE_INDEX(PACKAGE_ID, DRIVER_ID, FACTOR_ID, INDEX_SEQUENCE_ID, INDEX_TYPE, FROM_RANGE, TO_RANGE, STRING_VALUE, INT_VALUE, INDEX_VALUE); >> %TMP_SQL_FILE%
echo load from AHA.PACKAGE_TREATMENT.csv DELIMITER ',' INSERT INTO AHA.PACKAGE_TREATMENT(PACKAGE_ID, TREATMENT_ID, UNIT, UNIT_COST, SERVICE_LIFE_EXTENSION, SERVICE_LIFE_IMPROVEMENT, DESCRIPTION); >> %TMP_SQL_FILE%
echo load from AHA.PACKAGE_TREATMENT_INCLUDE.csv DELIMITER ',' INSERT INTO AHA.PACKAGE_TREATMENT_INCLUDE(PACKAGE_ID, TREATMENT_ID, DRIVER_ID, FROM_RANGE, TO_RANGE); >> %TMP_SQL_FILE%
echo load from AHA.PACKAGE_TREATMENT_EXCLUDE.csv DELIMITER ',' INSERT INTO AHA.PACKAGE_TREATMENT_EXCLUDE(PACKAGE_ID, TREATMENT_ID, DRIVER_ID, FACTOR_ID, SEQUENCE_ID, INDEX_TYPE, FROM_RANGE, TO_RANGE, STRING_VALUE, INT_VALUE, FILTER_NAME, FILTER_DESCRIPTION); >> %TMP_SQL_FILE%
echo load from AHA.PACKAGE_DEGRADATION.csv DELIMITER ',' INSERT INTO AHA.PACKAGE_DEGRADATION(PACKAGE_ID, FACTOR_ID, AGE, DESCRIPTION, CUMULATIVE_DEGRADATION); >> %TMP_SQL_FILE%

%DBCOMMAND% %TMP_SQL_FILE%

del %TMP_SQL_FILE%

@goto :EOF

:USAGE
echo.
echo Usage : load.bat db_name db_server
echo where
echo db_name:  Database Name, IFEDB
echo db_server:  Informix instance name
exit /b 0

:EOF



